#include <fstream.h>
#include <iomanip.h>
#define FIN "semafor.in"
#define FOUT "semafor.out"
#define MAX 5001

typedef struct nod {
	int nd;
	nod* urm;
} NOD, *PNOD;

PNOD l[MAX];   // lista de vecini
int t[MAX], v[MAX], c[MAX]; // tata, vizitat, coada
int p, s;   // nodul de plecare si sosire
ofstream fout(FOUT);


void AdInLista(int j, int i);
void Citeste();
void AfisDrum(int i, int pas); // cu i merg pe urma, t[i],
void BFS(int k);               // pas - adancimea recursiei == lung drumului minim

int main()
{
	Citeste();
	BFS( p );


	return 0;
}

void BFS(int k)
{
	int p = 1, u = 1; // prim, ultim in coada
	v[k] = 1; c[p] = c[u] = k; // il vizitez si-l pun in coada
	PNOD q = 0;

	while ( p <= u ) // cat timp mai am un nod in coada
	{
		q = l[c[p]];  // extrag primul vecin al primului nod din coada
		while ( q )     // parcurg lista de adiacenta
		{
			if ( !v[q->nd] )      // daca nu e vizitat
			{
				v[q->nd] = 1;	  // il vizitez
				t[q->nd] = c[p];  // retin parintele
				if ( q->nd == s )
				{
					AfisDrum(s, 1);
					return;
				}
				c[++u] = q->nd;   // il pun in coada
			}
			q = q->urm;
		}
		p++;  // avansez in coada
	}
}

void AdInLista(int j, int i)
{
	 PNOD p = new NOD;
	 p->nd = i;
	 p->urm = l[j];
	 l[j] = p;
}

void Citeste()
{
	int i = 0, j = 0;
	ifstream fin(FIN);
	fin >> p >> s;
	while ( fin >> i >> j )
		AdInLista(i, j);
	fin.close();
}


void AfisDrum(int i, int pas)
{
	if (t[i] == 0 )
	{
		fout << pas << endl
			 << i << " ";
		return;
	}
	AfisDrum(t[i], pas + 1);
	fout << i << " ";
}

